unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, ExtCtrls, TeeProcs, TeEngine, Chart, TeeComma, Series,
  TeePolar, TeeRose, Math, TeCanvas;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    TeeCommander1: TTeeCommander;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations } 
    Rose: TRoseSeries;
    procedure CustomLabelsPosition;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.CustomLabelsPosition;
const MarksOffset = 30;
var
  i : Integer;
  P : TPoint;
  Radius  : TPoint;
  Angle : TChartValue;
begin
  Radius:=TeePoint(Rose.XRadius + MarksOffset, Rose.YRadius + MarksOffset);
  
  for i:=0 to Rose.Marks.Positions.Count-1 do
  begin
    Angle:=DegToRad(Rose.AngleValues[i]);

    if Assigned(Rose.Marks.Positions[i]) then
    begin
      Rose.AngleToPos(Angle, Radius.X, Radius.Y, P.X, P.Y);
      Rose.Marks.Positions[i].Custom:=True;
      Rose.Marks.Positions[i].LeftTop.X:=P.X;
      Rose.Marks.Positions[i].LeftTop.Y:=P.Y;
      Rose.Marks.Positions[i].ArrowFrom.X:=P.X;
      Rose.Marks.Positions[i].ArrowFrom.Y:=P.Y;
    end;
  end;

  Rose.Repaint;
  Rose.RefreshSeries;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Rose:=TRoseSeries.Create(Self);
  Rose.FillSampleValues(); 
  Rose.AngleLabels.Visible:=False;
  Rose.Marks.Visible:=True;
  //Rose.Marks.Transparent:=True;
  Rose.Marks.Arrow.Visible:=True;

  Chart1.ClipPoints:=False;
  Chart1.View3D:=False;
  Chart1.AddSeries(Rose);

  Chart1.Draw;
  CustomLabelsPosition;
  Chart1.Draw;
end;

end.
